/*
 *  ArrayTools.c
 *  5CArrayBuilder
 *
 *  Created by James Fraser on Wednesday 03/12/08.
 *  Copyright 2008 McGill. All rights reserved.
 *
 */
#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <strings.h>

int list(char *numbers, int *num_list)
{
	int i;
	char *range = calloc(50, sizeof(char));
	int n =0, y,dash = -1, a, b,start = 0;
	char min[30], max[30];
	
	
	//Iterate through the string and separate based on commas
	for (i = 0; i <= strlen(numbers); i++)
	{
		
		
		if (numbers[i] == ',' || i == strlen(numbers))
		{
			
			
			//Dashed number
			if (start<dash && dash<i) {
				strncpy(min, numbers + start, dash-start);
				strncpy(max, numbers + dash +1, i-dash-1);
				
				
				start = i+1;
				a = atoi(min);
				b = atoi(max);
				
				for (y = a; y<=b; y++) {
					
					num_list[n] = y;
					n++;
					
				}
				
			} else { //lone number
				
				strncpy(range, numbers + start, i-start);
				start = i+1;
				num_list[n] = atoi(range);
				n++;
				
			}
			
		} else if (numbers[i] == '-') {
			
			dash = i;
			
		}
		
		range = calloc(50, sizeof(char));
		
		
	}

	
	return 0;
	
	
}

//Returns the number of primers entered
int process_input(FILE *input, char **primer_array, int direction)
{
	
	char trash[500], test[200], type[50];
	int i, index, n;
	
	//Identfies direction of primers of interest
	if (direction == 1) {
		
		strcpy(type, "Forward_Genomic");
		
	} else if (direction == -1) {
		
		strcpy(type, "Reverse_Genomic");
		
	} else {
		
		printf("ERROR\n");
		
		return -1;
		
	}
	
	
	
	//Gets information from header file and chucks it away (for now)
	for( i = 0; i<4;i++) {
		fgets(trash, 500, input);
	}
	
	//Identifies columns where genomic data is located for primers
	for (i = 0; strcmp(test, type)!=0; i++) {
		
		fscanf(input, "%s\t", test);
		
	}
	
	index = i;
	
	//Starts at the first line of code
	fgets(trash, 500, input);
	
	//iterates through the file
	for (i = 0; feof(input)==0; i++) {
		
		//iterates through line of forward file
		for (n = 0; n < index; n++) {
			fscanf(input, "%s\t", primer_array[i]);
		}
		
		fgets(trash, 500, input); //skips to the next line
		
	}
	
	
	return i-1;
}
